#ifndef DEVICE_H
#define DEVICE_H 1

#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>
#include "timestamp.h"
#include "visual.h"
#include "list.h"
#include "ipaddress.h"

class Subnet;
class Filter;
class Device : public Visual
{
	public:
		Device();
		~Device();

		void empty();
		void savexml(xmlNodePtr xmlnode);
		void loadxml(xmlNodePtr xmlnode, List *sns, List *mch);
		int match(char *str);
		void matchfilter(Filter *f);
		int matchsubnet(Subnet *s);

		IPAddress pingname;
		IPAddress pingname2;	// for merged devices
		char name[65];
		TimeStamp last_seen;
		char location[65];
		char community[65];
		char community2[65];
		char descr[65];
		char comment[129];
		char contact[65];
		char status;				// device up/down
		DeviceGroupType group;
		char grab_top;		// should be gboolean
		char grab_stats;	// should be gboolean
		List interfaces;
		DeviceType subtype;

//		char being_grabbed;
//		char find;
		int tag;		// used to tag a device for deletion when building a topology
		int tricky;	// used mark switches during tricky bit of layer 2 connect
};

int compare_device_names(Link *a, Link *b);
int compare_device_ips(Link *a, Link *b);

#endif

