#include <stdlib.h>
#include <string.h>
#include "level.h"
#include "action.h"

Level::Level()
{
	empty();
}

Level::~Level()
{
}

void Level::empty()
{
	Action *a;
	Link *ln;
	strcpy(name, "Unknown");
	strcpy(color, "#000000");
	for (ln=actions.get_head(); ln!=NULL; ln=ln->next)
	{ a = (Action*) ln->item; if (a!=NULL) delete a; } actions.empty();
}

void Level::save(xmlNodePtr xmlnode)
{
	xmlNodePtr newxml;
	char buf[32];
	Link *ln;
	Action *a;

	newxml = xmlNewChild(xmlnode, NULL, (xmlChar*)"Level", NULL);
	xmlSetProp(newxml, (xmlChar*)"name", (xmlChar*)name);
	xmlSetProp(newxml, (xmlChar*)"color", (xmlChar*)color);
	for (ln=actions.get_head(); ln!=NULL; ln=ln->next)
	{
		a = (Action*) ln->item;
		if (a!=NULL)
			a->save(newxml);
	}
}

void Level::load(xmlNodePtr xmlnode)
{
	xmlChar *buf;
	Action *a;

	if (!xmlnode || !xmlnode->name || strcmp((char*)xmlnode->name, "Level")!=0)
		return;
	empty();
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"name");
	if (buf!=NULL) { strcpy(name, (char*)buf); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"color");
	if (buf!=NULL) { strcpy(color, (char*)buf); free(buf); }

	xmlnode = xmlnode->childs;
	while (xmlnode != NULL)
	{
		if (xmlnode->name!=NULL)
		{
			if (strcmp((char*)xmlnode->name, "Action")==0)
			{
				a = new Action();
				a->load(xmlnode);
				actions.tag(a);
			}
		}
		xmlnode = xmlnode->next;
	}
}

